/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package nl.amis.comet.client.javapublisher;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;

/**
 *
 * @author lucas_j
 */
public class JavaCometPublisher {

    public static void main(String[] args) throws InterruptedException {
        JavaCometPublisher p = new JavaCometPublisher();
        try {
            Thread.sleep(5000);
            p.setSlide(2);
            Thread.sleep(2000);
            p.setSlide(4);
            Thread.sleep(2000);
            p.setSlide(3);
            Thread.sleep(2000);
            p.setSlide(5);
            Thread.sleep(2000);
            p.setSlide(1);
            Thread.sleep(2000);

        } catch (MalformedURLException e) {

            e.printStackTrace();

        } catch (IOException e) {

            e.printStackTrace();

        }

    }

    public static void setSlide(int slideNumber) throws IOException {
        String url = "http://localhost:8085/slideshow/cometd";
        String message = "[{\"version\":\"1.0\",\"minimumVersion\":\"0.9\",\"channel\":\"/meta/handshake\",\"supportedConnectionTypes\":[\"long-polling\",\"callback-polling\"],\"advice\":{\"timeout\":60000,\"interval\":0},\"id\":\"1\"}]";


        DefaultHttpClient httpClient = new DefaultHttpClient();
        String response = postToURL(url, message, httpClient);
        String clientId = response.substring(155, response.indexOf("\"", 155));
        System.out.println(clientId);
        String slideSelectionMessage = "[{\"channel\":\"/slide/show\",\"data\":{\"uniqueId\":1326523938212,\"slideNumber\":" + slideNumber + "},\"id\":\"40\",\"clientId\":\"" + clientId + "\"}]";
        response = postToURL(url, slideSelectionMessage, httpClient);
        System.out.println(response);

        httpClient.getConnectionManager().shutdown();

    }

    private static String postToURL(String url, String message, DefaultHttpClient httpClient) throws IOException, IllegalStateException, UnsupportedEncodingException, RuntimeException {
        HttpPost postRequest = new HttpPost(url);

        StringEntity input = new StringEntity(message);
        input.setContentType("application/json");
        postRequest.setEntity(input);

        HttpResponse response = httpClient.execute(postRequest);

        if (response.getStatusLine().getStatusCode() != 200) {
            throw new RuntimeException("Failed : HTTP error code : "
                    + response.getStatusLine().getStatusCode());
        }

        BufferedReader br = new BufferedReader(
                new InputStreamReader((response.getEntity().getContent())));

        String output;
        StringBuffer totalOutput = new StringBuffer();
        System.out.println("Output from Server .... \n");
        while ((output = br.readLine()) != null) {
            System.out.println(output);
            totalOutput.append(output);
        }
        return totalOutput.toString();
    }
}
